#ifndef _H_GLZ_ENCODER_CONFIG
#define _H_GLZ_ENCODER_CONFIG

#include "lz_common.h"

typedef void GlzUsrImageContext;
typedef struct GlzEncoderUsrContext GlzEncoderUsrContext;

struct GlzEncoderUsrContext {
    void    (*error)(GlzEncoderUsrContext *usr, const char *fmt, ...);
    void    (*warn)(GlzEncoderUsrContext *usr, const char *fmt, ...);
    void    (*info)(GlzEncoderUsrContext *usr, const char *fmt, ...);
    void    *(*malloc)(GlzEncoderUsrContext *usr, int size);
    void    (*free)(GlzEncoderUsrContext *usr, void *ptr);

    int     (*more_lines)(GlzEncoderUsrContext *usr, uint8_t **lines); // get the next chunk of the 
                                                                      // image which is entered to the dictionary.
                                                                      // If the image is down to top, return it from 
                                                                      // the last line to the first one 
                                                                      // (stride should always be positive)
    int	    (*more_space)(GlzEncoderUsrContext *usr, uint8_t **io_ptr); // get the next chunk of the 
                                                                       // compressed buffer. return 
                                                                       // number of bytes in the chunk.
    void    (*free_image)(GlzEncoderUsrContext *usr, GlzUsrImageContext *image); // called when an image
                                                                               // is removed from the 
                                                                               // dictionary, due to the
                                                                               // window size limit
};  


#ifdef DEBUG

#define GLZ_ASSERT(usr, x) \
    if (!(x)) (usr)->error(usr, "%s: ASSERT %s failed\n", __FUNCTION__, #x);

#else

#define GLZ_ASSERT(usr, x)

#endif

#define INLINE inline

#define FALSE 0
#define TRUE 1


#endif
